Program FORMAT_LLC2;

{formatiert disk mit 80*1024*5*2}


TYPE SECTORTYP = Record
                  f1 : array[1..12] of byte;
                  f2 : array[1..3] of byte;
                  f3 : byte;
                  tr : byte;
                  sd : byte;
                  se : byte;
                  sl : byte;
                  f4 : byte;
                  f5 : array[1..22] of byte;
                  f6 : array[1..12] of byte;
                  f7 : array[1..3] of byte;
                  f8 : byte;
                  dt : array[1..1024] of byte;
                  f9 : byte;
                  f10: array[1..115] of byte;
                 end;

    KOPFTYP   =  Record
                  f1 : array[1..80] of byte;
                  f2 : array[1..12] of byte;
                  f3 : array[1..3] of byte;
                  f4 : byte;
                  f5 : array[1..50] of byte;
                 end;

var Side,S,Error:byte;
    Akttrk:integer;
    ch:char;
    WrtPos:integer;
    llc:BOOLEAN;
    TrackDat : RECORD
                 TrKopf:KOPFTYP;
                 SEC1  :SECTORTYP;
                 SEC2  :SECTORTYP;
                 SEC3  :SECTORTYP;
                 SEC4  :SECTORTYP;
                 SEC5  :SECTORTYP;
                 LEER  :ARRAY[1..1024] OF BYTE;
               END;


procedure Puffinit(LLC:boolean);
 begin
  with trackDat do begin
   FILLCHAR(LEER,1024,$4E);
   with Trkopf do begin
    Fillchar(f1,80,$4E);
    FillChar(f2,12,$00);
    Fillchar(f3,3,$F6);
    f4:=$FC;
    Fillchar(f5,50,$4E);
   end;
   with Sec1 do begin
    Fillchar(f1,12,$00);
    Fillchar(f2,3,$F5);
    f3:=$FE;
    Sl:=03;    { Sectorlaenge = 1024byte }
    f4:=$F7;
    Fillchar(f5,22,$4E);
    Fillchar(f6,12,$00);
    Fillchar(f7,3,$F5);
    f8:=$FB;
    Fillchar(dt,1024,$E5);
    f9:=$F7;
    fillchar(f10,115,$4E);
   end;
   Sec2:=Sec1;
   Sec3:=Sec1;
   Sec4:=Sec1;
   Sec5:=Sec1;
   if LLC then begin
    Sec1.se:=1;
    Sec2.se:=4;
    Sec3.se:=2;
    Sec4.se:=5;
    Sec5.se:=3;
   end
   else begin
    Sec1.se:=1;
    Sec2.se:=2;
    Sec3.se:=3;
    Sec4.se:=4;
    Sec5.se:=5;
   end;
  end;
 end;

procedure Setpar(trk,Sid:byte);
 begin
  with Trackdat do begin
   Sec1.tr:=trk;
   Sec2.tr:=trk;
   Sec3.tr:=trk;
   Sec4.tr:=trk;
   Sec5.tr:=trk;
   Sec1.sd:=sid;
   Sec2.sd:=sid;
   Sec3.sd:=sid;
   Sec4.sd:=sid;
   Sec5.sd:=sid;
  end;
 end;



procedure Formating(sid:BYTE);
VAR TEST : BYTE;
begin
INLINE(
                        (*  ;DISK-Routinen fuer FDC WD2797              *)
                        (*  ;FDCstat INTRQ o. DRQ                       *)
                        (* FDCON    EQU 0C8H ;Motor/Select on           *)
                        (* FDCOFF   EQU 0CCH ;Motor/Select off          *)
                        (* FDCCOM   EQU 0C0H ;Commando + Status FDC     *)
                        (* FDCTRC   EQU 0C1H ;Trackregister             *)
                        (* FDCSEC   EQU 0C2H ;Sectorregister            *)
                        (* FDCDAT   EQU 0C3H ;Datenregister             *)
                        (* FDCSTAT  EQU 0C4H ;bit7 = DRQ bit6 = INTRQ   *)
$F3
/$3A/SID                (*          LD A,(SIDE) ;Var Side:byte (0,2);   *)
/$F6/$F4                (*          OR 0F4H ;Write Track                *)
/$32/TEST
/$D3/$C0                (* WRTS2    OUT (FDCCOM),A ;Start FORMAT-Command*)
/$DD/$E3                (*          EX (SP),IX                          *)
/$DD/$E3                (*          EX (SP),IX                          *)
/$21/TRACKDAT           (*          LD HL,TRACKDAT ;1024 byte Zwischenpu*)
/$0E/$C3                (*          LD C,FDCDAT ;IO-Adresse             *)
/$16/$C0                (*          LD D,0C0H ;MASKEN                   *)
/$06/$01                (*          LD B,01                             *)
/$1E/$19                (*          LD E,23 ;22*256+1*204               *)
/$DB/$C0                (* WRTS3    IN A,(FDCCOM) ;11                   *)
/$CB/$4F                (*          BIT 1,A ; 8 if DRQ                  *)
/$C2/*+$0009            (*          JP NZ,WRTS4 ;10 ja dann Daten schrei*)
/$A0                    (*          AND B ; 4 if /BUSY                  *)
/$C2/*+$FFF7            (*          JP NZ,WRTS3 ;10 nein dann warten    *)
/$C3/*+$001E            (*          JP FDCERR ;ja Abbruch-Fehler        *)
/$ED/$A3                (* WRTS4    OUTI                                *)
/$06/$CB                (*          LD B,203 ;Zaehler 256 byte (203 beim*)
/$DB/$C4                (* WRTS5    IN A,(FDCSTAT) ;11  warten auf DRQ o*)
/$AA                    (*          XOR D ;4                            *)
/$A2                    (*          AND D ;4                            *)
/$CA/*+$FFFB            (*          JP Z,WRTS5 ;10                      *)
/$ED/$A3                (*          OUTI  ;16  256 byte laden           *)
/$C2/*+$FFF6            (*          JP NZ,WRTS5 ;10                     *)
/$1D                    (*          DEC E ;4   e*256 byte               *)
/$C2/*+$FFF2            (*          JP NZ,WRTS5 ;10                     *)
/$DB/$C0                (* WRTS6    IN A,(FDCCOM) ;FehlerStatus         *)
/$CB/$47                (*          BIT 0,A ;warten auf /BUSY           *)
/$C2/*+$FFFB            (*          JP NZ,WRTS6                         *)
/$FB                    (*          EI                                  *)
/$DB/$C0                (* FDCERR   IN A,(FDCCOM)                       *)
/$32/ERROR              (*          LD (ERROR),A                        *)
/$22/WRTPOS             (*          LD (WRTPOS),HL                      *)
/$FB
                        (* ERROR    EXT                                 *)
                        (* SIDE     EXT                                 *)
                        (* WRTPOS   EXT                                 *)
                        (* TRACKDAT EXT                                 *)
)
;
end;


procedure FDCStep;
 var OK:boolean;
 begin
  port[$C0]:=$48;
  repeat
   OK:=(port[$C0] and $01)=1;
  until not OK;
 end;



begin
 clrscr;
 WRITELN(^J^J);
 writeln('Formating DISK ! All Data deleted !');
 write('LLC2-Format (phys. Sectoren 14253) Y/N?');
 repeat
  read(kbd,ch);
 until ch in ['Y','y','N','n'];
 if ch in ['Y','y'] then LLC:=true else LLC:=false;
 WRITELN;
 write('Start Y/N ?');
 Read(kbd,ch);
 write(ch);
 if ch <>'Y' then halt;
 port[$C8]:=0;
 port[$C0]:=00;
 delay(2000);
 Puffinit(llc);
 for Akttrk:=0 to 79 do begin
  for s:=0 to 1 do begin
   Side:=s*2;
   gotoxy(1,10);
   write('  Zylinder:',akttrk:2,' Seite:',S:1);
   Setpar(Akttrk,S);
   PORT[$C8]:=0;
   Formating(s*2);
   WRITELN('  Sollbytes:6348  Istbytes:',WRTPOS-Addr(Trackdat):4);
   if (error and $C7) <> 0 then begin
     writeln(^g^g^g^g^g^g'Error on Track:',Akttrk:3,' with ErrorCode:',Error:3);
     port[$CC]:=0;
     halt;
   end;
  end;
  FDCStep;
 end;
 writeln;
 writeln(^g^g'Formating OK.');
 port[$CC]:=0;
end.






